:- use_module(library(clpb)).
:- op(700, fy, nem).     
:- op(800, yfx, s).
:- op(900, yfx, vagy).  
:- op(950, xfy, mondja).

A mondja ll :-
	rtke(A mondja ll, 1).

% rtke(llts, rtk): Az llts igazsgrtke rtk.
rtke(X = Y, E) :-        sat((X =:= Y) =:= E).
rtke(X mondja M, E) :-   rtke(M, E0), sat((E0 =:= X) =:= E).
rtke(M1 s M2, E) :-     rtke(M1, E1), rtke(M2, E2), sat(E =:= E1*E2).
rtke(M1 vagy M2, E) :-   rtke(M1, E1), rtke(M2, E2), sat(E =:= E1+E2).
rtke(nem M, E) :-        rtke(M, E0), sat(E =:= ~E0).

end_of_file.

| ?- Alfrd mondja Alfrd = 0 vagy Bla = 0.
        Bla = 0, Alfrd = 1 ? ; no
| ?- A mondja B mondja C mondja A = C. 
        B = 1 ? ; no
| ?- A mondja B = C.
        sat(B=\=C#A) ? ; no
| ?- A mondja B = C, labeling([A,B,C]).
        A = 0, B = 1, C = 0 ? ; A = 0, B = 0, C = 1 ? ;
        A = 1, B = 0, C = 0 ? ; A = 1, B = 1, C = 1 ? ; no
