:- use_module(library(clpfd)).

:- op(700, fy, nem).     
:- op(800, yfx, s).     
:- op(900, yfx, vagy).  
:- op(950, xfy, mondja).

A mondja ll :- rtke(A mondja ll, 1).

% rtke(llts, rtk): Az llts igazsgrtke rtk.
rtke(X = Y, E) :-       X in 0..1, Y in 0..1, E #<=> (X #= Y).
rtke(X mondja M, E) :-  X in 0..1, rtke(M, E0), E #<=> (E0 #= X).
rtke(M1 s M2, E) :-    rtke(M1, E1), rtke(M2, E2), E #<=> E1 #/\ E2.
rtke(M1 vagy M2, E) :-  rtke(M1, E1), rtke(M2, E2), E #<=> E1 #\/ E2.
rtke(nem M, E) :-       rtke(M, E0), E #<=> #\ E0.

end_of_file.



| ?- Alfrd mondja Alfrd = 0 vagy Bla = 0.
        Alfrd in 0..1, Bla in 0..1 ? ; no
| ?- Alfrd mondja Alfrd = 0 vagy Bla = 0, labeling([], [Alfrd,Bla]).
        Bla = 0, Alfrd = 1 ? ; no
| ?- A mondja B = C, labeling([], [A,B,C]).
        A = 0, B = 0, C = 1 ? ; A = 0, B = 1, C = 0 ? ; 
        A = 1, B = 0, C = 0 ? ; A = 1, B = 1, C = 1 ? ; no
