:- use_module(library(lists), [member/2, reverse/2]).

jrat('Budapest', 'Prga', 515).
jrat('Budapest', 'Bcs', 245).
jrat('Bcs', 'Berlin', 635).
jrat('Bcs', 'Prizs', 1265).


% tszakasz(A, B, H): A-bl B-be eljuthatunk egy H thossz jrattal.
tszakasz(Kezdet, Cl, Tv) :-
     (   jrat(Kezdet, Cl, Tv)
     ;   jrat(Cl, Kezdet, Tv)
     ).

% tvonal_2(N, A, B, t, H): A s B kztt van (pontosan)
% N szakaszbl ll krmentes  t tvonal, amelynek sszhossza H.
tvonal_2(N, Honnan, Hov, t, H) :-
        tvonal_2(N, Honnan, Hov,  [Honnan], t, H).

% tvonal_2(N, A, B, K, t, H): A s B kztt van pontosan
% N szakaszbl ll krmentes, K elemein t nem men H hossz  t t.
tvonal_2(0, Hov, Hov,  Kizrtak, t, 0)  :- 
	reverse(Kizrtak, t).
tvonal_2(N, Honnan, Hov, Kizrtak,  t, H) :-
        N > 0, N1 is N-1, 
        tszakasz(Honnan, Kzben, H1),
        \+ member(Kzben, Kizrtak),
        tvonal_2(N1, Kzben, Hov, [Kzben|Kizrtak],  t, H2), 
	H is H1+H2.
