:- op(700, fy, nem).     
:- op(800, yfx, s).
:- op(900, yfx, vagy).  
:- op(950, xfy, mondja).

% Az A bennszltt mondhatja az ll lltst.
A mondja ll :-
	rtke(A mondja ll, 1).

% rtke(llts, rtk): llts igazsgrtke rtk (1 = igaz, 0 = hamis).
rtke(X = X, 1).
% rtke(X = Y, 1) :-
%	azonos(X, Y).
rtke(X = Y, 0) :-
	klnbz(X, Y).
rtke(lovag mondja M, E) :-
	rtke(M, E).
rtke(lkt mondja M, E) :-
	rtke(nem M, E).
rtke(M1 s M2, E) :-
	rtke(M1, E1), rtke(M2, E2),  E is E1 /\ E2.
rtke(M1 vagy M2, E) :-
	rtke(M1, E1), rtke(M2, E2),  E is E1 \/ E2.
rtke(nem M, E) :-
	rtke(M, E1),                   E is 1-E1.

% klnbz(A, B): A s B klnbz tpus bennszlttek.
klnbz(lovag, lkt).
klnbz(lkt, lovag).

azonos(lovag, lovag).
azonos(lkt, lkt).

end_of_file.

| ?- Alfrd mondja Alfrd = lkt vagy Bla = lkt.
        Bla = lkt, Alfrd = lovag ? ; no

| ?- A mondja B = C.
        A = lovag, C = B ? ; 
        A = lkt, B = lovag, C = lkt ? ;
        A = lkt, B = lkt, C = lovag ? ; no

| ?- A mondja B mondja C mondja A = C.
	A = lovag, B = lovag, C = lovag ? ;
	A = lovag, B = lovag, C = lkt ? ;
	A = lkt, B = lovag, C = lovag ? ;
	A = lkt, B = lovag, C = lkt ? ; no
