% :- type tree2 == integer \/ {node(tree2,tree2)}.

sum_tree2(Tree, Sum) :-
	integer(Tree), Sum = Tree.
sum_tree2(node(Left,Right), Sum) :-
	sum_tree2(Left, Sum1),
	sum_tree2(Right, Sum2),
	Sum is Sum1+Sum2.

% :- sum_tree2(5+(3+2), Sum), write(Sum), nl.

